﻿if(typeof(WINDOW_CHANGE) != "boolean") {
	WINDOW_CHANGE = true;

if (typeof(Cc) == "undefined")
  var Cc = Components.classes;
if (typeof(Ci) == "undefined")
  var Ci = Components.interfaces;
  
var fs = false;
var curViewMode;
var tvMode = TV_START;
var noEventTime = 5100;
var winMaxed = false;
var resizers = ["resizer-left", "resizer-right", "resizer-top", "resizer-bottom", "resizer-topleft", "resizer-bottomright"];

function toggleFullScreen()
{
    fs = !fs;
    noEventTime = 5100;
    if (fs) {
        for(var i in resizers)
            $(resizers[i]).hidden = true;
        mp.setWindowTop(true);
        hideAllExceptVideo(true);
        window.maximize();
    } else {
        if(curViewMode != VIEW_TV) {
			for(var i in resizers)
            $(resizers[i]).hidden = false;
			window.restore();
		}
        setViewMode();
        //toggleMediaLib();
        if(!isChecked("windowTop"))
            mp.setWindowTop(false);
    }
}

function toggleMaximize()
{
	winMaxed = !winMaxed;
	if (winMaxed)
		window.maximize();
	else
		window.restore();
}

function toggleDualMode()
{
    dualmode = isChecked("dualMode");
    $('dualVideoOptions').hidden = !dualmode;
    if (!dualmode) {
        mp.setActivePlayer(0);
		mp.exitDualMode();
    } 
    //window.sizeToContent();
}

/*
function slideViewMode(mode)
{
	if (!curViewMode) return;
	switch (mode) {
	case VIEW_FULL:
		$("fullView").setAttribute("checked", true);
		break;
	case VIEW_SIMPLE:
		$("simpleView").setAttribute("checked", true);
		break;
	case VIEW_DEVICE:
		$("deviceView").setAttribute("checked", true);
		break;
	case VIEW_COMPACT:
		$("compactView").setAttribute("checked", true);
		break;
	}
	setViewMode(mode);
}
*/

function setViewMode(mode)
{
	var titlebar = $('titlebar');
	var tabs = $('mainTab');
	var playToolbar = $("bottomBar");
	var splitter = $("panelSplit");
	var mcexContainer = $("mcexBox");
	var mcexSplitter = $("mcexSplitter");
	var medialibPanel = $("tabMediaLib");
	if (!mode) {
		mode = parseInt($('optViewMode').value);
	} else {
		$('optViewMode').value = mode;
	}
	
	switch (mode) {
	case VIEW_FULL:
	case VIEW_DEVICE:
		titlebar.hidden = false;
		tabs.hidden = false;
		playToolbar.hidden = false;
		splitter.hidden = false;
		break;
	case VIEW_SIMPLE:
		titlebar.hidden = false;
		tabs.hidden = true;
		toolbar.hidden = true;
		playToolbar.hidden = true;
		splitter.hidden = true;
		break;
	case VIEW_COMPACT:
		titlebar.hidden = false;
		tabs.hidden = true;
		toolbar.hidden = true;
		playToolbar.hidden = false;
		splitter.hidden = true;
		break;
	case VIEW_TV:
		titlebar.hidden = true;
		tabs.hidden = true;
		toolbar.hidden = true;
		playToolbar.hidden = true;
		splitter.hidden = true;
		break;
	}
		
	if (mode != curViewMode) {
		// view mode has been changed
		var isDeviceMode = (mode == VIEW_DEVICE);
		mcexContainer.hidden = !isDeviceMode;
		mcexSplitter.hidden = !isDeviceMode;
		var isTVMode = (mode == VIEW_TV);
		for(var i in resizers) {
			var aResizer = $(resizers[i]);
			aResizer.hidden = isTVMode;
		}
		medialibPanel.hidden = !isTVMode;
		if (isTVMode) {
			homeURL = "html/tv/mediacenter.html";
			setTVMode(tvMode);
		} else {
			homeURL = getLocalString("homeURL");
			if (!homeURL) homeURL = "http://xulplayer.sourceforge.net/start";
			if (curViewMode == VIEW_TV) {
				$("topdeck").selectedIndex = 0;
				if (winMaxed) toggleMaximize();
			}
		}
		if (!mp.isPlaying())		
			loadPage(homeURL);
		curViewMode = mode;
	}

	onResize();
}

function setTVMode(mode, submode)
{
	$("topdeck").selectedIndex = (tvMode = mode);
}

function zoomVideo()
{
    if (isChecked("keep25")) {
        mp.zoom(0.25);
    } else if (isChecked("keep50")) {
        mp.zoom(0.5);
    } else if (isChecked("keep150")) {
        mp.zoom(1.5);
    } else if (isChecked("keep200")) {
        mp.zoom(2);
    } else if (isChecked("keep100")) {
        mp.zoom(1);
    } else if (isChecked("keepvideo")){
        mp.zoom(-1.5);  // Need a number < 0 , but can't be negative integer
        fitVideoSize(false);
    } else {
        mp.zoom(0);
    }
}

function fitVideoSize(ifOriginal)
{
    var vh = 0, vw = 0;
    if(ifOriginal){
        vh = mp.getVideoHeight(); vw = mp.getVideoWidth();
    } else {
        vw = mp.getRealVideoWidth(); vh = mp.getRealVideoHeight(); 
    }
    if(vh <= 0 || vw <= 0 || vh > window.screen.height || vw > window.screen.width) return;
    var boxh = $("videoBox").boxObject.height;
    var boxw = $("videoBox").boxObject.width;
    var h = window.innerHeight, w = window.innerWidth;
    window.innerWidth = w - boxw + vw;
    window.innerHeight = h - boxh + vh;
    onResize();
}

function setWindowTop()
{
	var winTopmost = isChecked("windowTop");
    mp.setWindowTop(winTopmost);
}

function setWindowTopByKey()
{
	var winTopmost = isChecked("windowTop");
	$('windowTop').setAttribute('checked', !winTopmost);
	mp.setWindowTop(!winTopmost);
}

function focusMethod()
{
    if(focusFromPlugin){
		focusFromPlugin = false;
        $('windowIcon').focus();
        if(fs){
            noEventTime = 0;
            $("bottomBar").hidden = false;
        }
    }
}

function onResize()
{
    if (winMaxed) return false;;
    switch (curViewMode) {
    case VIEW_DEVICE:
        if (window.outerWidth < 1000)
            window.outerWidth=1000;
        if (window.outerHeight < 550)
            window.outerHeight=550;
	break;
    case VIEW_FULL:
        if (window.outerWidth < 720)
            window.outerWidth=720;
        if (window.outerHeight < 510)
            window.outerHeight=510;
	break;
    case VIEW_COMPACT:
    case VIEW_SIMPLE:
        if (window.outerWidth < 720 )
            window.outerWidth=720;
        if (window.outerHeight < 270)
            window.outerHeight=270;
		break;
	case VIEW_TV:
		if(!winMaxed) toggleMaximize();
		break;
    }
    return true;  
}

function hideAllExceptVideo(ifHide)
{
    var elements = [$("titlebar"), $('mainTab'), 
                    $('bottomBar'), $("panelSplit"), $("tabMediaLib")];
    for each(var elem in elements){
		elem.hidden = ifHide;
    }
}
function showOrHideProgressbar()    //when noEvent time is bigger than 1500, hide progressbar
{
    noEventTime += mp.m_timeInterval;
    if(noEventTime > 5000)
        $("bottomBar").hidden = true;
    else
        $("bottomBar").hidden = false;
    if(noEventTime > 20000) noEventTime = 20000;
}       

/*
function toggleMediaLib()
{
    var mlbar = $("media-lib-bar");
	mlbar.hidden = true;
    mlbar.nextSibling.hidden = true;
    if ($("menu-show-ml").getAttribute("checked") == "true") {
            mlbar.hidden = false;
            mlbar.nextSibling.hidden = false;
            var xsl = loadXML("medialib/catalog.xsl");
            var xml = loadXML("file:///" + mediaLibPath + "\\filelist.xml");
            if (xsl && xml) transformXML(xml, xsl, "file-list");
    } else {
            mlbar.hidden = true;
            mlbar.nextSibling.hidden = true;
    }
}*/

// Attempt to restart the app
function restartApp()
{
	// Notify all windows that an application quit has been requested.
	var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
	var cancelQuit = Cc["@mozilla.org/supports-PRBool;1"].createInstance(Ci.nsISupportsPRBool);
	os.notifyObservers(cancelQuit, "quit-application-requested", "restart");
  
	// Something aborted the quit process.
	if (cancelQuit.data)
	  return;
  
	// attempt to restart
	var as = Cc["@mozilla.org/toolkit/app-startup;1"].getService(Ci.nsIAppStartup);
	as.quit(Components.interfaces.nsIAppStartup.eRestart |
			Components.interfaces.nsIAppStartup.eAttemptQuit);
  
	closeWindow();
}

function closeWindow()
{
	mp.setTrayIcon(false);
	window.close();
}


function getStyle(elem,styleProp)
{
  var v = null;
  if (elem) {
    var s = document.defaultView.getComputedStyle(elem,null);
    v = s.getPropertyValue(styleProp);
  }
  return v;
}

/**
 * Simple JS container that holds rectangle information
 * for (x, y) and (width, height).
 */
function CScreenRect(inWidth, inHeight, inX, inY) {
  this.width = inWidth;
  this.height = inHeight;
  this.x = inX;
  this.y = inY;
}

/**
 * Get the current maximum available screen rect based on which screen
 * the window is currently on.
 * @return A |CScreenRect| object containing the max available 
 *         coordinates of the current screen.
 */
function getCurMaxScreenRect() {
  var screenManager = Cc["@mozilla.org/gfx/screenmanager;1"]
                        .getService(Ci.nsIScreenManager);
                        
  var curX = parseInt(document.documentElement.boxObject.screenX);
  var curY = parseInt(document.documentElement.boxObject.screenY);
  var curWidth = parseInt(document.documentElement.boxObject.width);
  var curHeight = parseInt(document.documentElement.boxObject.height);
  
  var curScreen = screenManager.screenForRect(curX, curY, curWidth, curHeight);
  var x = {}, y = {}, width = {}, height = {};
  curScreen.GetAvailRect(x, y, width, height);
  
  return new CScreenRect(width.value, height.value, x.value, y.value);
}

}
