/*
 p2p.js
*/
if(typeof(XULPLAYER_P2P_INCLUDE) != "boolean") {
	XULPLAYER_P2P_INCLUDE = true;
    function CP2p(pluginObj) {
        this.m_plugin = pluginObj;
        this.state = CP2p.STATE_IDLE;
    }
    
    CP2p.STATE_IDLE = 0;
    CP2p.STATE_STARTED = 1;
    
    CP2p.prototype.initialize = function() {
        this.m_plugin.init();
    };
    
    CP2p.prototype.start = function() {
        ret = this.m_plugin.P2P_Start()
        if (ret == true) {
            this.state = CP2p.STATE_STARTED;
        }
        return ret;
    };
    
    CP2p.prototype.stop = function() {
        ret = this.m_plugin.P2P_Stop();
        if (ret == true) {
            this.state = CP2p.STATE_IDLE;
        }
        return ret;
    }
    
    CP2p.prototype.download = function(url) {
        if (this.state == CP2p.STATE_IDLE) {
            alert("P2P client has not started.");
        }
        return this.m_plugin.P2P_Download(url);
    }
}